/* MIDI Out demo program.
 * Author: Qiushi Jiang
 * This program plays one note for 1 second and pause for 1 second then repeat.
 */
#include <stdio.h>
#include "includes.h"

/* Definition of Task Stacks */
#define   TASK_STACKSIZE       2048
OS_STK    task1_stk[TASK_STACKSIZE];

/* Definition of Task Priorities */

#define TASK1_PRIORITY      1

unsigned int getMidiData(unsigned int statusByte,unsigned int pitchByte,unsigned int velocityBtye){
	//formate: 	0 statusBtye 1	0 pitchByte 1	0 velocityByte 1
	return (statusByte<<21) + (1<<20) + (0<<19) + (pitchByte<<11) + (1<<10) + (0<<9) + (velocityBtye<<1) +(1<<0);

}

/* Prints "Hello World" and sleeps for three seconds */
void task1(void* pdata){
	int* midiOutPointer = (int*) MIDIOUT_0_BASE;
	printf("Start sending MIDI Signal at GPIO_0[0]\n");

	while (1){
		*midiOutPointer = getMidiData(0x90,0x3c,0x40);	// C4 note on with velocity set to 64
		printf("Sending note on\n");
		OSTimeDlyHMSM(0, 0, 1, 0);						// Hold the note for 1 second

		/*
		* According to midi specification, note on with velocity 0 is the same as note off
		* In fact after reversing engineering several midi keyboard we find this is actually
		* a more common implementation of note off.
		*/
		printf("Sending note off\n");
		*midiOutPointer = getMidiData(0x90,0x3c,0x00);	// C4 note on with velocity set to 0
		OSTimeDlyHMSM(0, 0, 1, 0);						// silence for 1 second
	}
}

/* The main function creates two task and starts multi-tasking */
int main(void){
  
  OSTaskCreateExt(task1,
                  NULL,
                  (void *)&task1_stk[TASK_STACKSIZE-1],
                  TASK1_PRIORITY,
                  TASK1_PRIORITY,
                  task1_stk,
                  TASK_STACKSIZE,
                  NULL,
                  0);
              

  OSStart();
  return 0;
}
